/*
	Copyright 2006 EarthLink, Inc. All rights reserved.
*/

/* start dhtml building blocks */
function freezeEvent(e) {
if (e.preventDefault) e.preventDefault();
e.returnValue = false;
e.cancelBubble = true;
if (e.stopPropagation) e.stopPropagation();
return false;
}//freezeEvent

function isWithinNode(e,i,c,t,obj) {
answer = false;
te = e;
while(te && !answer) {
	if	((te.id && (te.id == i)) || (te.className && (te.className == i+"Class"))
			|| (!t && c && te.className && (te.className == c))
			|| (!t && c && te.className && (te.className.indexOf(c) != -1))
			|| (t && te.tagName && (te.tagName.toLowerCase() == t))
			|| (obj && (te == obj))
		) {
		answer = te;
	} else {
		te = te.parentNode;
	}
}
return te;
}//isWithinNode

function getEvent(event) {
return (event ? event : window.event);
}//getEvent()

function getEventElement(e) {
return (e.srcElement ? e.srcElement: (e.target ? e.target : e.currentTarget));
}//getEventElement()

function getSibling(isNext, currentNode) {
answer = null;
if (currentNode) {
	testNode = currentNode;
	tag = currentNode.tagName.toLowerCase();
	cName = currentNode.className;
	while (!answer && (testNode = (isNext ? testNode.nextSibling : testNode.previousSibling))) {
		if	(
				(
					tag && (t = testNode.tagName) &&
					(t.toLowerCase() == tag)
				)
				||
				(
					cName && (testNode.className) &&
					(testNode.className.indexOf(cName) != -1)
				)
			) {
			answer = testNode;
		}
	}//loop thru siblings;
}//if valid currentNode is passed
return answer;
}//getSibling()

function getNextSibling(elmt,classMatch) {
refTag = elmt.tagName;
if (refTag) refTag = refTag.toLowerCase();
elmt = elmt.nextSibling;
while (elmt && ( !elmt.className || ((elmt.tagName != refTag) && (elmt.className != classMatch) && (elmt.className.indexOf(classMatch) == -1)) ))
			elmt = elmt.nextSibling;
return elmt;
}//getNextSibling

function getPreviousSibling(elmt,classMatch) {
refTag = elmt.tagName;
if (refTag) refTag = refTag.toLowerCase();
elmt = elmt.previousSibling;
while (elmt && ( !elmt.className || ((elmt.tagName != refTag) && (elmt.className != classMatch) && (elmt.className.indexOf(classMatch) == -1)) ))
			elmt = elmt.previousSibling;
return elmt;
}//getPreviousSibling

function getLastChild(elmt,classMatch) {
refTag = elmt.tagName;
if (refTag) refTag = refTag.toLowerCase();
while (elmt && ( !elmt.className || (elmt.className != classMatch)))
	elmt = elmt.previousSibling;
return elmt;
}//getLastChild()

function setClassValue(o,v) {
c = o.className;
re = new RegExp(" *" + v + " *","gi");
c = c.replace(re,"");
o.className = c + " " + v;
}//setClassValue

function unsetClassValue(o,v) {
c = o.className;
re = new RegExp(" *" + v + " *","gi");
c = c.replace(re,"");
o.className = c;
}//unsetClassValue

function togDis(o) {
	if ((o.style.display == "") || (o.style.display == "block") )
		o.style.display = "none";
	else
		o.style.display = "block";
	}//togDis

function getTextData(node) {
	s = "";
	if (node) {
		c = node.firstChild;
		while (c) {
			if ((c.nodeType == TEXT_NODE) || (c.nodeType == CDATA_NODE)) {
				s += c.data;
			}
			c = c.nextSibling;
		}
		//alert(s);
	}
	return s;
}//getTextData

function $a(n,a) {
	if (n) {
		return n.getAttribute(a);	
	} else return null;
}//getAttribute

function $t(s) {
	return document.createTextNode(s);
}//createTextNode

function $e(s) {
	return document.createElement(s);
}//createElement

function $$(n,t) {
	result = null
	if (n) {
		result = n.getElementsByTagNameNS("",t)[0];
		if (result == null) result = n.getElementsByTagName(t)[0];
	}
	return result;
}//getSingleElement

function $$m(n,t) {
	result = null
	if (n) {
		result = n.getElementsByTagNameNS("",t);
		if ((result == null) || (result.length == 0)) result = n.getElementsByTagName(t);
	}
	return result;
}//getMultipleElements

function $(i) {
	return document.getElementById(i);
}//getElementById

function $$mc(tagName, cName, refElement) {
	searchElement = refElement ? refElement : document;
	dels = searchElement.getElementsByTagName(tagName);
	els = new Array(); j = 0;
	for (t = 0; dels[t]; t++) {
		if (
				(c = dels[t].className)
					&&
					(
						(c == cName) || (c.indexOf(cName) != -1)
					)
			) {
			els[j] = dels[t];
			j++;
		}
	}
	if (els.length == 0) els = null;
	return els;
}//getElementsByClassName

/* end dhtml building blocks */

/* start core */
function StringBuffer() {
     this.__strings__ = new Array;
}

StringBuffer.prototype.append = function(str) {
     this.__strings__.push(str);
}

StringBuffer.prototype.toString = function(separator) {
	 if (!separator) separator = "";
     return this.__strings__.join(separator);
}

function getDateFromString(str) {
	str = str.substring(0,str.indexOf("Z"));
	result = new Date();
	dateFields = str.split("T")[0].split("-");
	timeFields = str.split("T")[1].split(":");
	tf = timeFields[0];
	hour = getInt(tf);
	dateUTCmillisec = Date.UTC(
	getInt(dateFields[0]),
	(getInt(dateFields[1]) - 1),
	getInt(dateFields[2]),
	hour,
	getInt(timeFields[1]),
	getInt(timeFields[2]),
	0
	);
	result = new Date(dateUTCmillisec);	
	return result;
}//

function getInt(s) {
s = s.replace(/^ *0+/gi,'');
if ((s == "") || (s.indexOf(".") == 0)) s = 0;
i = parseInt(s);
return i;
}

function debug(s) {
	if (DEBUG_ENABLED) alert(s);
}//debug

/* end core */

/* start selecting */

function displayItem(item, fromClick) {
	unSelectAllItems();
	selectItem(item, fromClick);
	showDetailView(item);
}//displayItem

function unSelectAllItems() {
	liTags = document.getElementsByTagName(ITEM_SELECT_TAG_NAME);
	i = 0;
	while (t = liTags[i]) {
	unsetClassValue(t,"selected");
	i++;
	}
}//unSelectAllItems

selectedItem = null;

function selectItem(item, fromClick) {
	setClassValue(item,"selected");
	selectedItem = item;

	if (!fromClick) {
		chbox = item.getElementsByTagName("input");
		if (chbox) chbox = chbox[0];
		if (chbox) {
			chbox.focus();
		}
/*		if (item.scrollIntoView) {
			if (item.nextSibling)
				item.nextSibling.firstChild.scrollIntoView(false);
			else
				item.firstChild.scrollIntoView(false);
		}//method exists
*/
	}//not from clicking
}//selectItem

function selectNextItem() {
	if (selectedItem) {
		nextItem = getSibling(true, selectedItem);
		if (!nextItem) {
			//items = selectedItem.parentNode.getElementsByTagName(ITEM_SELECT_TAG_NAME);
			//nextItem = items[0];
		}
		if (nextItem) displayItem(nextItem);
	}
}//selectNextItem()

function selectPreviousItem() {
	if (selectedItem) {
		previousItem = getSibling(false, selectedItem);
		if (!previousItem) {
			//items = selectedItem.parentNode.getElementsByTagName(ITEM_SELECT_TAG_NAME);
			//previousItem = items[items.length - 1];
		}
		if (previousItem) displayItem(previousItem);
	}
}//selectPreviousItem

/* end selecting */

/* start flashing */

TRANS_SPEED_MILLISECS = 50;
PULSE_INTERVAL_MILLISECS = 1000;
flashLimit = 10;
transStart = 255;
transEnd = 153; //153
transInc = -12;
colorBase = "FFFF";

transTemp = 0;
transCurrent = transStart;
stopFlash = false;
flashEl = null;
flashCount = 0;
flashTimeout = null;

function selectFlashElements() {
	flashEl = new Array();
	flashElCounter = 0;
	
	suggMenu = $("suggMenuContainer");
	if (suggMenu) {
		flashEl[flashElCounter] = suggMenu;
		flashElCounter++;
	}
}//selectFlashElements

function trans() {
if	(	
!stopFlash &&
(
((transInc > 0) && (transEnd > transCurrent))
||
((transInc < 0) && (transEnd < transCurrent))
)
) {
setFlashElementsToColor(colorBase + dec2hex(transCurrent));
transCurrent += transInc;
timeoutTwo = setTimeout("trans()",TRANS_SPEED_MILLISECS);
}//call self on timeout
}//trans()

function dec2hex(theDec) {
retNum = "FF";
if (theDec < 255) {
leftNum = Math.floor(theDec / 16);
leftNumS = fixHex(leftNum);
rightNum = theDec%16;
rightNumS = fixHex(rightNum);
retNum = leftNumS + rightNumS;
}
return retNum;
}//dec2hex()
hNum = new Array("0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F");
function fixHex(theDec) {
return hNum[theDec];
}//fixHex()

function setFlashElementsToColor(c) {
for (k=0;flashEl && flashEl[k]; k++){
flashEl[k].style.backgroundColor = c;
}//loop thru flash Els, set color;
}//setFlashElementsColors

function initTrans() {
transTemp = transStart;
transStart = transEnd;
transEnd = transTemp;
transInc *= -1;
transCurrent = transStart;
}//initTrans()

function twitch() {
if (flashEl) {
initTrans();
trans();
if (stopFlash || (flashCount > flashLimit)) {
stopFlash = true;
setFlashElementsToColor("");
flashCount = 0;
flashEl = null;
} else {
flashCount++;
flashTimeout = setTimeout('twitch()', PULSE_INTERVAL_MILLISECS);
}
}//elements we're flashing exist
}//twitch

function startFlash() {
	clearTimeout(flashTimeout);
	flashCount = 0;
	stopFlash = false;
	selectFlashElements();
	twitch();
}//startFlash

/* end flashing */

/* start contextual menu */
	function togCM() {
	if (cm && cm.menu) togDis(cm.menu);
	}//showCM()
	function killCM() {
	togCM();cm = null;
	}//killCM()
	function contextualMenu() { }
	cm = null;
	
	function handleContextualMenuMouseOver(event) {
		e = getEvent(event);
		eL = getEventElement(e);
		if (!window.mw) {
			if (	!cm 
					&&
					(
						(cmt = isWithinNode(eL,null,"cmTrigger"))
					)
				) {
				cm = new contextualMenu();
				cm.trigger = cmt;
				if (cmt.cmMenu) {
					cm.menu = cmt.cmMenu;
				} else {
					cm.menu = getNextSibling(cmt,"cmMenu");
				}
				togCM();
			} else if (cm && (/* isWithinNode(eL,null,null,null,cm.menu) || */ isWithinNode(eL,null,null,null,cm.trigger))) {
				clearTimeout(cm.hideMenuTimer);
			} else if (cm) {
				cm.hideMenuTimer = setTimeout('killCM()',200);
			} else {
				window.status = "";
			}
		}//make sure we're not in the middle of a drag and drop
	}//handleContextualMenuMouseOver
/* end contextual menu */